#ifndef __H_Sleep_H__
#define __H_Sleep_H__

#include <windows.h>


void _Sleep(int nTimeOut)
{
    __int64		start, cur, freq;
	double		diff;
	DWORD		dwMin=10;
	DWORD		dwTimeOut = (DWORD)nTimeOut;


	// If Sleep is >= dwMin or no performance counters are available then use native Sleep()
	if (dwTimeOut >= dwMin || !QueryPerformanceCounter((LARGE_INTEGER *)&start))
	{
		::Sleep(dwTimeOut);
		return;
	}

	// Get frequency
	QueryPerformanceFrequency((LARGE_INTEGER *)&freq);

	// Note that we must at least do a Sleep(0) once otherwise the SendTo functions get out of
	// sync - especially on 9x/NT4 but also had one report for XP too (seems be on the keydowndelay)
	do
	{
		::Sleep(0);								// Reduce CPU usage - Sleep 0 is special
		QueryPerformanceCounter((LARGE_INTEGER *)&cur);
		diff = ((double)(cur - start) / (double)freq) * 1000.0;

	} while ((DWORD)diff < dwTimeOut);
}

#endif

