#include "GUI.h"
#include "autoit-sendkeys/sendkeys.cpp.h"


#ifndef __H_Control_H__
#define __H_Control_H__


bool _IsWinHung(HWND hWnd, UINT nTimeOut=5000);
bool _IsWinHung(HWND hWnd, UINT nTimeOut)
{
	DWORD dwResult;

	if (SendMessageTimeout(hWnd, WM_NULL, 0, 0, SMTO_ABORTIFHUNG, nTimeOut, &dwResult))
		return false;
	else
		return true;
}
void _AttachThreadInput(HWND hWnd, bool bAttach)
{
	if (bAttach == true)
	{
		if (_IsWinHung(hWnd) == false)
			AttachThreadInput(GetCurrentThreadId(),GetWindowThreadProcessId(hWnd, NULL), TRUE);
	}
	else
		AttachThreadInput(GetCurrentThreadId(),GetWindowThreadProcessId(hWnd, NULL), FALSE);
}



class Any
{
public:
    union _Any_
    {
        void *p;
        double d;
    } _u;
    
    Any() {_u.p=NULL;}
    
    Any(int i) {_u.p=(void*)i;}
    Any(double i) {_u.d=i;}
    Any(char *i)
    {
        string x=i;
        char *xx=const_cast<char*>(x.c_str());
        _u.p=(void*)xx;
    }
    Any(void *i) {_u.p=i;}
    
    Any& operator = (int i) {_u.p=(void*)i;}
    Any& operator = (double i) {_u.d=i;}
    Any& operator = (char *i)
    {
        string x=i;
        char *xx=const_cast<char*>(x.c_str());
        _u.p=(void*)xx;
    }
    Any& operator = (void *i) {_u.p=i;}
    
    int GetInt() {return (int)_u.p;}
    double GetDouble() {return _u.d;}
    char* GetSz() {return (char*)_u.p;}
    void* GetP() {return _u.p;}
};



char *_cid;
int num;
BOOL CALLBACK _ECProc(HWND hwnd,LPARAM lpa)
{
    Control *nc=(Control*)lpa;
    char tem[256];
    GetClassName(hwnd,tem,255);
    string temp=tem;
    string str=_cid;
    int n=(int)str.find(temp);
    if (n!=-1)
    {
        num++;
        str=str.substr(n+(int)temp.length());
        n=atoi(str.c_str());
        if (num!=n) return TRUE;
    }
    else
    {
        return TRUE;
    }
    nc->Set(hwnd,tem);
    nc->idoftype=num;
    char t[10];
    itoa(nc->idoftype,t,10);
    nc->id=cat(nc->type,t);
    return FALSE;
}

Control _ControlSearch(HWND hwnd,char *cid)
{
    Control nc;
    _cid=cid;
    num=0;
    EnumChildWindows(hwnd,_ECProc,(LPARAM)&nc);
    return nc;
}


void ControlSetText(HWND hwnd,char *cid,char *txt="");
void ControlSetText(HWND hwnd,char *cid,char *txt)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    nc.SetData(txt);
}

char* ControlGetText(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return "";
    return nc.Read();
}

void ControlClick(HWND hwnd,char *cid,char *button="left",int clicks=1,int x=-1,int y=-1);
void ControlClick(HWND hwnd,char *cid,char *button,int clicks,int x,int y)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    
    UINT	msgdown, msgup;
	WPARAM	wParam;
	RECT	rect;
	LPARAM	lParam;
	
	_AttachThreadInput(hwnd, true);
	//SetActiveWindow(hwnd); //Window aktivieren
	GetWindowRect(nc.chwnd, &rect);
	lParam = MAKELPARAM( (x==-1?((rect.right - rect.left) / 2):x), (y==-1?((rect.bottom - rect.top) / 2):y));
    
    msgdown = WM_LBUTTONDOWN; //"left"
	msgup	= WM_LBUTTONUP;
	wParam	= MK_LBUTTON;
	if (!stricmp(button,"right"))
	{
        msgdown = WM_RBUTTONDOWN;
		msgup	= WM_RBUTTONUP;
		wParam	= MK_RBUTTON;
    }
    else if (!stricmp(button,"middle"))
    {
        msgdown = WM_MBUTTONDOWN;
		msgup	= WM_MBUTTONUP;
		wParam	= MK_MBUTTON;
    }
    
    for (int i=0; i<clicks; ++i)
	{
		PostMessage(nc.chwnd, msgdown, wParam, lParam);
		PostMessage(nc.chwnd, msgup, 0, lParam);
		_Sleep(10);
	}

	_AttachThreadInput(hwnd, false);
}

Control ControlGetHandle(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    return nc;
}

void ControlEnable(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    nc.Enable();
}

void ControlDisable(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    nc.Disable();
}

void ControlShow(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    nc.Show();
}

void ControlHide(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    nc.Hide();
}

void ControlFocus(HWND hwnd,char *cid)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    _AttachThreadInput(hwnd, true);
    SetFocus(nc.chwnd);
    _AttachThreadInput(hwnd, false);
}

int __num;
char _szCn[256];
BOOL CALLBACK _CGFProc(HWND hwnd,LPARAM lpa)
{
    char szBuffer[256];
	GetClassName(hwnd, szBuffer, 255);
	if (!strcmp(szBuffer,_szCn))
	{
        __num++;
        if (hwnd==(HWND)lpa) return FALSE;
    }
    return TRUE;
}
Control ControlGetFocus(HWND hwnd)
{
    Control nc;
    HWND h;
    _AttachThreadInput(hwnd, true);
    h=GetFocus();
    _AttachThreadInput(hwnd, false);
    
    __num=0;
    GetClassName(h, _szCn, 255);
    EnumChildWindows(hwnd,_CGFProc,(LPARAM)h);
    
    nc.Set(h,_szCn);
    nc.idoftype=__num;
    char t[10];
    itoa(nc.idoftype,t,10);
    nc.id=cat(nc.type,t);
    return nc;
}

Any ControlCommand(HWND hwnd,char *cid,char *szCmd="IsVisible",Any opt="");
Any ControlCommand(HWND hwnd,char *cid,char *szCmd,Any opt)
{
    char	szBuffer[32000+1];
	UINT		vMsg = 0;
	UINT		xMsg = 0;
	UINT		yMsg = 0;
	RECT		rect;
	LPARAM		lParam;
	Any		vResult;
    
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) { vResult=-1; return vResult; }
    

	_AttachThreadInput(hwnd, true);
	while (true)
	{
		if ( strcmpi(szCmd,"ISVISIBLE")==0 )
		{
			if ( IsWindowVisible(nc.chwnd) )
				vResult = 1;
			else
				vResult = 0;
			break;							// ISENABLED performed, exit switch
		}
		if ( strcmpi(szCmd,"ISENABLED")==0 )
		{
			if ( IsWindowEnabled(nc.chwnd) )
				vResult = 1;
			else
				vResult = 0;
			break;							// ISENABLED performed, exit switch
		}
		if ( strcmpi(szCmd,"TABLEFT")==0 )
		{// must be a Tab Control
			PostMessage(nc.chwnd, WM_KEYDOWN, VK_LEFT, (LPARAM)( (MapVirtualKey(VK_LEFT, 0)<<16) | 0x00000001 ) );
			Sleep(0);
			PostMessage(nc.chwnd, WM_KEYUP, VK_LEFT, (LPARAM)( (MapVirtualKey(VK_LEFT, 0)<<16) | 0xC0000001 ) );
			break;							// TABLEFT performed, exit switch
		}
		if ( strcmpi(szCmd,"TABRIGHT")==0 )
		{// must be a Tab Control
			PostMessage(nc.chwnd,WM_KEYDOWN,VK_RIGHT, (LPARAM)( (MapVirtualKey(VK_LEFT, 0)<<16) | 0x00000001 ) );
			Sleep(0);
			PostMessage(nc.chwnd,WM_KEYUP,VK_RIGHT, (LPARAM)( (MapVirtualKey(VK_LEFT, 0)<<16) | 0xC0000001 ));
			break;							// TABRIGHT performed, exit switch
		}
		if ( strcmpi(szCmd,"CURRENTTAB")==0 )
		{// must be a Tab Control
			int nTab = (int)SendMessage(nc.chwnd,TCM_GETCURSEL,opt.GetInt(),0);
			nTab++;
			vResult = nTab;
			break;							// CURRENTTAB performed, exit switch
		}

		if ( strcmpi(szCmd,"SHOWDROPDOWN")==0 )
		{// must be a ComboBox
			SendMessage(nc.chwnd, CB_SHOWDROPDOWN, (WPARAM)TRUE, 0);
			break;							// SHOWDROPDOWN performed, exit switch
		}

		if ( strcmpi(szCmd,"HIDEDROPDOWN")==0 )
		{// must be a ComboBox
			SendMessage(nc.chwnd, CB_SHOWDROPDOWN, (WPARAM)FALSE, 0);
			break;							// HIDEDROPDOWN performed, exit switch
		}

		if ( strcmpi(szCmd,"ADDSTRING")==0 )
		{
			if ( strnicmp(nc.type,"Combo",5)==0 )
				vMsg = CB_ADDSTRING;
			if ( strnicmp(nc.type,"List",4)==0 )
				vMsg = LB_ADDSTRING;
			if ( vMsg )
			{// Must be ComboBox or ListBox
				SendMessage(nc.chwnd, vMsg, 0, (LPARAM)opt.GetSz());
			}
			break;							// ADDSTRING performed, exit switch
		}

		if ( strcmpi(szCmd,"DELSTRING")==0 )
		{
			if ( strnicmp(nc.type,"Combo",5)==0 )
				vMsg = CB_DELETESTRING;
			if ( strnicmp(nc.type,"List",4)==0 )
				vMsg = LB_DELETESTRING;
			if ( vMsg )
			{// Must be ComboBox or ListBox
				SendMessage(nc.chwnd, vMsg, (WPARAM)opt.GetInt(), 0);
			}
			break;							// DELSTRING performed, exit switch
		}

		if ( strcmpi(szCmd,"FINDSTRING")==0 )
		{
			if ( strnicmp(nc.type,"Combo",5)==0 )
				vMsg = CB_FINDSTRINGEXACT;
			if ( strnicmp(nc.type,"List",4)==0 )
				vMsg = LB_FINDSTRINGEXACT;
			if ( vMsg )
			{// Must be ComboBox or ListBox
				vResult = (int)SendMessage(nc.chwnd, vMsg, (WPARAM)1, (LPARAM)opt.GetSz());
            }
			break;							// FINDSTRING performed, exit switch
		}

		if ( strcmpi(szCmd,"SETCURRENTSELECTION")==0 )
		{
			if ( strnicmp(nc.type,"Combo",5)==0 )
			{
				vMsg = CB_SETCURSEL;
				xMsg = CBN_SELCHANGE;
				yMsg = CBN_SELENDOK;
			}
			if ( strnicmp(nc.type,"List",4)==0 )
			{
				vMsg = LB_SETCURSEL;
				xMsg = LBN_SELCHANGE;
				yMsg = LBN_DBLCLK;
			}
			if ( vMsg )
			{// Must be ComboBox or ListBox
				if ( SendMessage(nc.chwnd, vMsg, (WPARAM)opt.GetInt(), 0) != -1 )
				{
					SendMessage(GetParent(nc.chwnd),WM_COMMAND,(WPARAM)MAKELONG(GetDlgCtrlID(nc.chwnd),xMsg),(LPARAM)nc.chwnd);
					SendMessage(GetParent(nc.chwnd),WM_COMMAND,(WPARAM)MAKELONG(GetDlgCtrlID(nc.chwnd),yMsg),(LPARAM)nc.chwnd);
				}
			}
			break;							// SETCURRENTSELECTION performed, exit switch
		}

		if ( stricmp(szCmd,"GETCURRENTSELECTION")==0 )
		{
			if ( strnicmp(nc.type,"ComboBox",8)==0 )
			{
				vMsg = CB_GETCURSEL;
				xMsg = CB_GETLBTEXTLEN;
				yMsg = CB_GETLBTEXT;
			}
			if ( strnicmp(nc.type,"ListBox",7)==0 )
			{
				vMsg = LB_GETCURSEL;
				xMsg = LB_GETTEXTLEN;
				yMsg = LB_GETTEXT;
			}
			if ( vMsg )
			{// Must be ComboBox or ListBox
				int          nIndex, nLen;
				nIndex = (int)SendMessage(nc.chwnd, vMsg, 0, 0);
				if ( nIndex != -1)
				{
					nLen = (int)SendMessage(nc.chwnd,xMsg,(WPARAM)nIndex,0);
					if ( nLen != -1 )
					{
						char     *pBuffer = NULL;
						nLen++;
						pBuffer=(char*)calloc(256+nLen,1);
						nLen = (int)SendMessage(nc.chwnd,yMsg,(WPARAM)nIndex,(LPARAM)pBuffer);
						if ( nLen != -1 )
								vResult = pBuffer;
						if(pBuffer)
								free(pBuffer);
					}
				}
			}
			break;     // GETCURRENTSELECTION performed, exit switch
		}

		if ( strcmpi(szCmd,"SELECTSTRING")==0 )
		{
			if ( strnicmp(nc.type,"ComboBox",8)==0 )
			{
				vMsg = CB_SELECTSTRING;
				xMsg = CBN_SELCHANGE;
				yMsg = CBN_SELENDOK;
			}
			if ( strnicmp(nc.type,"ListBox",7)==0 )
			{
				vMsg = LB_SELECTSTRING;
				xMsg = LBN_SELCHANGE;
				yMsg = LBN_DBLCLK;
			}
			if ( vMsg )
			{// Must be ComboBox or ListBox
				if ( SendMessage(nc.chwnd, vMsg, (WPARAM)1, (LPARAM)opt.GetSz()) != -1 )
				{
					SendMessage(GetParent(nc.chwnd),WM_COMMAND,(WPARAM)MAKELONG(GetDlgCtrlID(nc.chwnd),xMsg),(LPARAM)nc.chwnd);
					SendMessage(GetParent(nc.chwnd),WM_COMMAND,(WPARAM)MAKELONG(GetDlgCtrlID(nc.chwnd),yMsg),(LPARAM)nc.chwnd);
				}
			}
			break;							// SELECTSTRING performed, exit switch
		}

		if ( strcmpi(szCmd,"ISCHECKED")==0  )
		{//Must be a Button
			if ( SendMessage(nc.chwnd,BM_GETCHECK, 0, 0) == BST_CHECKED )
				vResult = 1;				// Is checked (0 is default/not checked)
			else
				vResult = 0;
			break;							// ISCHECKED performed, exit switch
		}

		if ( strcmpi(szCmd,"CHECK")==0 )
		{//Must be a Button
			// Only send the "check" if the button is not already checked
			if ( SendMessage(nc.chwnd,BM_GETCHECK, 0, 0) == BST_UNCHECKED )
			{
				//SetActiveWindow(hwnd);		// See BM_CLICK docs, applies to this too
				GetWindowRect(nc.chwnd, &rect);	// Code to primary click the centre of the control
				lParam = MAKELPARAM( (rect.right - rect.left) / 2, (rect.bottom - rect.top) / 2);
				PostMessage(nc.chwnd, WM_LBUTTONDOWN, MK_LBUTTON, lParam);
				PostMessage(nc.chwnd, WM_LBUTTONUP, 0, lParam);
			}
			break;							// CHECK performed, exit switch
		}

		if ( strcmpi(szCmd,"UNCHECK")==0 )
		{//Must be a Button
			// Only send the "uncheck" if the button is not already unchecked
			if ( SendMessage(nc.chwnd,BM_GETCHECK, 0, 0) == BST_CHECKED )
			{
				//SendMessage(nc.chwnd,BM_SETCHECK,(WPARAM)BST_UNCHECKED, 0);
				//SendMessage(GetParent(nc.chwnd),WM_COMMAND,(WPARAM)MAKELONG(GetDlgCtrlID(nc.chwnd),BN_CLICKED),(LPARAM)nc.chwnd);
				SetActiveWindow(hwnd);		// See BM_CLICK docs, applies to this too
				GetWindowRect(nc.chwnd, &rect);	// Code to primary click the centre of the control
				lParam = MAKELPARAM( (rect.right - rect.left) / 2, (rect.bottom - rect.top) / 2);
				PostMessage(nc.chwnd, WM_LBUTTONDOWN, MK_LBUTTON, lParam);
				PostMessage(nc.chwnd, WM_LBUTTONUP, 0, lParam);
			}
				break;							// UNCHECK performed, exit switch
		}

		if ( strcmpi(szCmd,"GETSELECTED")==0 )
		{//Must be an Edit
			UINT	nLen,nStart,nEnd;
			char	*pBuffer = NULL;

			SendMessage(nc.chwnd,EM_GETSEL,(WPARAM)&nStart,(LPARAM)&nEnd);
			if (nStart!=nEnd)
			{
				if ( (nLen = (int)SendMessage(nc.chwnd,WM_GETTEXTLENGTH,0 , 0)) )
				{
					pBuffer=(char*)calloc(256+nLen,1);
					if ( SendMessage(nc.chwnd,WM_GETTEXT,(WPARAM)(nLen+1), (LPARAM)pBuffer) && nEnd <= 32000 )
					{
						if (nEnd != nLen )
							pBuffer[nEnd]='\0';
						vResult = pBuffer+nStart;
					}
				}
			}
			if(pBuffer)
				free(pBuffer);
			break;							// GETSELECTED performed, exit switch
		}

		if ( strcmpi(szCmd,"GETLINECOUNT")==0 )
		{//Must be an Edit
			vResult = (int)SendMessage(nc.chwnd,EM_GETLINECOUNT, 0, 0);
			break;							// GETLINECOUNT performed, exit switch
		}

		if ( strcmpi(szCmd,"GETCURRENTLINE")==0 )
		{
			vResult = (int)SendMessage(nc.chwnd,EM_LINEFROMCHAR, (WPARAM)-1, 0)+1;
			break;
		}

		if ( strcmpi(szCmd,"GETCURRENTCOL")==0 )
		{
			UINT nStart, nEnd, nOriginal;
			int  nLine;

			SendMessage(nc.chwnd,EM_GETSEL,(WPARAM)&nStart,(LPARAM)&nEnd);
			nOriginal = nStart;  //the charcter index

			//Decrement the character index until the row changes
			//Difference between this char index and original is the column.

			nLine = (int)SendMessage(nc.chwnd,EM_LINEFROMCHAR,(WPARAM)nStart,0);
			if (nLine >= 1)
			{
				while (nLine == (int)SendMessage(nc.chwnd,EM_LINEFROMCHAR,(WPARAM)nStart,0))
				{
					nStart--;
				}
				vResult = (int)nOriginal - (int)nStart;  //no off-by one error :)
			}
			else
				vResult = (int)nStart + 1;  //add 1 because first char index is 0
			break;
		}

		if ( strcmpi(szCmd,"EDITPASTE")==0 )
		{
			SendMessage(nc.chwnd,EM_REPLACESEL, TRUE, (LPARAM)opt.GetSz());
			break;
		}
		if ( strcmpi(szCmd,"GETLINE")==0 )
		{
			int nFoo;
			*((LPINT)szBuffer) = sizeof(szBuffer);

			nFoo = (int)SendMessage(nc.chwnd, EM_GETLINE, (WPARAM)opt.GetInt()-1, (LPARAM)szBuffer);
			if ( nFoo )
			{
				szBuffer[nFoo]='\0';
				vResult = szBuffer;
			}
			break;							// GETLINE performed, exit switch
		}
		break;
	}
	_AttachThreadInput(hwnd, false);

	return vResult;
}

POINT ControlGetPos(HWND hwnd,char *cid)
{
    POINT p={-1,-1};
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return p;
    p=WinGetPos(nc.chwnd);
    ScreenToClient(hwnd,&p);
    return p;
}

void ControlMove(HWND hwnd,char *cid,int x,int y,int w=-1,int h=-1);
void ControlMove(HWND hwnd,char *cid,int x,int y,int w,int h)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    
    RECT rect;
    _AttachThreadInput(hwnd, true);
    GetWindowRect(hwnd, &rect);
    w=(w==-1?rect.right-rect.left:w);
    h=(h==-1?rect.bottom-rect.top:h);
    MoveWindow(nc.chwnd,x,y,w,h,true);
    _AttachThreadInput(hwnd, false);
}

void ControlSend(HWND hwnd,char *cid,char *txt,bool raw=false,int keydowndelay=1,int keydelay=5);
void ControlSend(HWND hwnd,char *cid,char *txt,bool raw,int keydowndelay,int keydelay)
{
    Control nc=_ControlSearch(hwnd,cid);
    if (nc.chwnd==NULL) return;
    
    HS_SendKeys sk; //Init in Constructor
    sk.Init();
    sk.SetKeyDownDelay(keydowndelay);
    sk.SetKeyDelay(keydelay);
    if (raw)
		sk.SendRaw(txt, nc.chwnd);
	else
		sk.Send(txt, nc.chwnd);
}

void Util_RegReadString(HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpValueName, DWORD dwBufLen, char *szValue )
{
	HKEY	hRegKey;

	// Make sure the return value is blank just in case we error
	szValue[0] = '\0';

	if (RegOpenKeyEx(hKey, lpSubKey, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return;

	RegQueryValueEx(hRegKey, lpValueName, NULL, NULL, (LPBYTE)szValue, &dwBufLen);

	RegCloseKey(hRegKey);

}

void MouseDown(char *button="primary");
void MouseDown(char *button)
{
    char swapped[4];
	DWORD event=0;

	if ( button[0] == '\0' || stricmp(button, "LEFT")==0 ) // empty string or "left"
		event = MOUSEEVENTF_LEFTDOWN;
	else if ( stricmp(button,"RIGHT")==0 )
		event = MOUSEEVENTF_RIGHTDOWN;
	else if ( stricmp(button,"MIDDLE")==0 )
		event = MOUSEEVENTF_MIDDLEDOWN;
	else
	{
		Util_RegReadString(HKEY_CURRENT_USER, "Control Panel\\Mouse", "SwapMouseButtons", 4, swapped );
		if ( swapped[0] == '1')	// buttons swapped
		{
			if ( stricmp(button,"MAIN")==0 || stricmp(button, "PRIMARY"))
				event = MOUSEEVENTF_RIGHTDOWN;
			else if ( stricmp(button,"MENU")==0 || stricmp(button, "SECONDARY"))
				event = MOUSEEVENTF_LEFTDOWN;
		}
		else
		{
			if ( stricmp(button,"MAIN")==0 || stricmp(button, "PRIMARY"))
				event = MOUSEEVENTF_LEFTDOWN;
			else if ( stricmp(button,"MENU")==0 || stricmp(button, "SECONDARY"))
				event = MOUSEEVENTF_RIGHTDOWN;
		}
	}
	if (event != 0) {
		mouse_event(event, 0, 0, 0, 0);
	}
}

void MouseUp(char *button="primary");
void MouseUp(char *button)
{
    char swapped[4];
	DWORD event = 0;	// default to 0 in case no strings match

	if ( button[0] == '\0' || stricmp(button, "LEFT")==0 ) // empty string or "left"
		event = MOUSEEVENTF_LEFTUP;
	else if ( stricmp(button,"RIGHT")==0 )
		event = MOUSEEVENTF_RIGHTUP;
	else if ( stricmp(button,"MIDDLE")==0 )
		event = MOUSEEVENTF_MIDDLEUP;
	else
	{
		Util_RegReadString(HKEY_CURRENT_USER, "Control Panel\\Mouse", "SwapMouseButtons", 4, swapped );
		if ( swapped[0] = '1')	// buttons swapped
		{
			if ( stricmp(button,"MAIN")==0 || stricmp(button, "PRIMARY"))
				event = MOUSEEVENTF_RIGHTUP;
			else if ( stricmp(button,"MENU")==0 || stricmp(button, "SECONDARY"))
				event = MOUSEEVENTF_LEFTUP;
		}
		else
		{
			if ( stricmp(button,"MAIN")==0 || stricmp(button, "PRIMARY"))
				event = MOUSEEVENTF_LEFTUP;
			else if ( stricmp(button,"MENU")==0 || stricmp(button, "SECONDARY"))
				event = MOUSEEVENTF_RIGHTUP;
		}
	}
	if (event != 0) {
		mouse_event(event, 0, 0, 0, 0);
	}
}

void MouseClick(char *button="primary",int x=0,int y=0,int num=1);
void MouseClick(char *button,int x,int y,int num)
{
	SetCursorPos(x,y);
	for (int i=0; i<num; ++i)
	{
		MouseDown(button);
		_Sleep(10);
		MouseUp(button);
		_Sleep(10);
	}
}

//ControlListView und ControlTreeView nicht im Autoit-Src, nicht nachgebaut

#endif



