#undef _WIN32_WINNT
#define _WIN32_WINNT 0x501
#include <windows.h>
#include <commctrl.h>
#include "multi.h"
#include "Win.h"




#ifndef H__GUI__H
#define H__GUI__H


#define GUICLOSE -1
#define GUIPath _ThisFilename()

class GUI
{
      public:
             HWND hwnd;
             UINT msg;      //Last Message
             WPARAM wparam; //"
             LPARAM lparam; //"
             GUI()
             {
                  hwnd=NULL;
                  msg=wparam=lparam=0;
             }
};

struct newGUI
{
       char *title;
       int w,h,style,exstyle,posx,posy;
       HWND parent;
       int guix;
       bool start;
       char *classname;
       bool useexstyle;
};

struct delGUI
{
    HWND hwnd;
    bool start;
    bool fertig;
};


class Control
{
    public:
        HWND chwnd;
        char *id;
        char *type;
        int idoftype;
        int cmsg;
        
        Control()
        {
            chwnd=NULL;
            id="";
            type="";
            idoftype=0;
            cmsg=0;
        }
        
        void Set(HWND hwnd,char *typ)
        {
            chwnd=hwnd;
            type=typ;
            idoftype=GetDlgCtrlID(chwnd);
            char t[10];
            itoa(idoftype,t,10);
            id=cat(type,t);
        }
        
        bool operator == (Control nc)
        {
            return (chwnd==nc.chwnd);
        }
        bool operator != (Control nc)
        {
            return !(chwnd==nc.chwnd);
        }
        
        bool operator == (int i)
        {
            return (i==cmsg);
        }
        
        bool operator != (int i)
        {
            return (i!=cmsg);
        }
        
        void InfoBox()
        {
            char buff[500];
            char temp[50];
            itoa((DWORD)chwnd,temp,16);
            strcpy(buff,cat(cat("cHWND: ",temp),"\n"));
            itoa((DWORD)idoftype,temp,10);
            strcat(buff,cat(cat("IDoftype: ",temp),"\n"));
            itoa((DWORD)cmsg,temp,10);
            strcat(buff,cat("cMSG: ",temp));
            strcat(buff,cat("\nType: ",type));
            MessageBox(0,buff,"InfoBox",0);
        }
        
        void SetFont(HFONT fon)
        {
            SendMessage(chwnd, WM_SETFONT, (WPARAM)fon, MAKELPARAM(TRUE, 0));
        }
        
        void FillType()
        {
            char temp[101];
            GetClassName(chwnd,temp,101);
            strcpy(type,temp);
        }
        
        void SetData(char *txt)//only own Controls
        {//SendMessage for Controls of other Apps
            SendMessage(chwnd,WM_SETTEXT,0,(LPARAM)txt);
        }
        
        bool operator ==(char *c)
        {
            return !(stricmp(Read(),c));
        }
        
        bool operator !=(char *c)
        {
            return (stricmp(Read(),c));
        }
        
        void Enable()
        {
            EnableWindow(chwnd,TRUE);
        }
        
        void Disable()
        {
            EnableWindow(chwnd,FALSE);
        }
        
        char* Read()
        {//SendMessage for Controls of other Apps
            int length=1+(int)SendMessage(chwnd,WM_GETTEXTLENGTH,0,0);
            char *temp=new char[length];
            SendMessage(chwnd,WM_GETTEXT,length,(LPARAM)temp);
            return temp;
        }
        
        void Show()
        {
            ShowWindow(chwnd,SW_SHOW);
        }
        
        void Hide()
        {
            ShowWindow(chwnd,SW_HIDE);
        }
        
        Control operator = (char *txt)
        {
            this->SetData(txt);
            return (Control)*this;
        }
        
        void SetState(int state)
        {
            ShowWindow(chwnd,state);
        }
        
        int GetState()
        {
            return WinGetState(chwnd);
        }
};


//Global
WNDCLASSEX wincl;
char clname[]="TheShadowAE's GUI";
int guis=0;
GUI *gui[51];
bool msgloop=true;
HANDLE thread;
HINSTANCE hinst;
newGUI *newG;
delGUI dG={NULL,false,false};
bool finished=false;




//Functions
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

//official
void GUIStartup();
void GUIShutdown();
GUI* GUICreate(char* title="",int w=300,int h=200,int style=WS_OVERLAPPEDWINDOW,int exstyle=0,HWND parent=HWND_DESKTOP,int posx=CW_USEDEFAULT,int posy=CW_USEDEFAULT);
void GUIDelete(GUI *ngui);
void GUISetState(GUI *ngui,int state=SW_SHOW);
int GUIGetStyle(GUI *ngui);
void GUISetStyle(GUI *ngui,int style);
int GUIGetExstyle(GUI *ngui);
void GUISetExstyle(GUI *ngui,int exstyle);
void GUISetIcon(GUI *ngui,char *iconpath);
void GUISetIcon(GUI *ngui,HICON hicon,HICON hiconsm);
void GUISetCurser(GUI *ngui,char *name);
void GUIEnable(GUI *ngui);
void GUIDisable(GUI *ngui);
void GUISetFont(GUI *ngui,HFONT font);
Control GUIGetMessage(GUI *ngui);
Control GUICtrlCreateButton(GUI *ngui,char *txt,int x,int y,int w,int h,int style=BS_PUSHBUTTON);
Control GUICtrlCreateRadio(GUI *ngui,char *txt,int x,int y,int w,int h,int style=0);
Control GUICtrlCreateCheckbox(GUI *ngui,char *txt,int x,int y,int w,int h,int style=0);
Control GUICtrlCreateGroup(GUI *ngui,char *txt,int x,int y,int w,int h,int style=ES_LEFT);
Control GUICtrlCreateCombo(GUI *ngui,char *txt,int x,int y,int w,int h,int style=CBS_DROPDOWN);
Control GUICtrlCreateInput(GUI *ngui,char *txt,int x,int y,int w,int h,int style=ES_AUTOHSCROLL);
Control GUICtrlCreateEdit(GUI *ngui,char *txt,int x,int y,int w,int h,int style=ES_AUTOHSCROLL);
Control GUICtrlCreateList(GUI *ngui,char *txt,int x,int y,int w,int h,int style=0);
Control GUICtrlCreateLabel(GUI *ngui,char *txt,int x,int y,int w,int h,int style=0);
Control GUICtrlCreateScrollbar(GUI *ngui,char *txt,int x,int y,int w,int h,int style=0);
void GUICtrlDelete(Control nc);
void GUICtrlSetColor(Control nc,int color);
void GUICtrlSetBkColor(Control nc,int color);
void GUICtrlSetPos(Control nc,int x,int y);
void GUICtrlSetPos(Control nc,int x,int y,int w,int h);
void GUIRegisterMessage(int msg);
void GUIUnregisterMessage(int msg);



//inofficial
DWORD WINAPI _Handler(LPVOID);
Control _GUICtrlCreate(char *type,char *title,int posx,int posy,int w,int h,int style,HWND parent);
char* _ThisFilename();





void GUIDelete(GUI *ngui)
{ //Rest in Proc
    dG.hwnd=ngui->hwnd;
    dG.start=true;
    while (!dG.fertig) Sleep(10);
    dG.fertig=false;
}

void GUICtrlDelete(Control nc)
{
    dG.hwnd=nc.chwnd;
    dG.start=true;
    while (!dG.fertig) Sleep(10);
    dG.fertig=false;
}

Control GUICtrlCreateButton(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("button",txt,x,y,w,h,style,ngui->hwnd);
}

Control GUICtrlCreateScrollbar(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("scrollbar",txt,x,y,w,h,style,ngui->hwnd);
}

Control GUICtrlCreateLabel(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{//can be used with SS_BITMAP and SS_ICON usw...
    return _GUICtrlCreate("static",txt,x,y,w,h,style,ngui->hwnd);
}

Control GUICtrlCreateList(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{//can be used with LBS_SORT usw...
    return _GUICtrlCreate("listbox",txt,x,y,w,h,style,ngui->hwnd);
}

Control GUICtrlCreateEdit(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("edit",txt,x,y,w,h,ES_MULTILINE|style,ngui->hwnd);
}

Control GUICtrlCreateInput(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("edit",txt,x,y,w,h,style,ngui->hwnd);
}

Control GUICtrlCreateCombo(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("comcobox",txt,x,y,w,h,style,ngui->hwnd);
}

Control GUICtrlCreateGroup(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("button",txt,x,y,w,h,BS_GROUPBOX|style,ngui->hwnd);
}

Control GUICtrlCreateCheckbox(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("button",txt,x,y,w,h,BS_AUTOCHECKBOX|style,ngui->hwnd);
}

Control GUICtrlCreateRadio(GUI *ngui,char *txt,int x,int y,int w,int h,int style)
{
    return _GUICtrlCreate("button",txt,x,y,w,h,BS_AUTORADIOBUTTON|style,ngui->hwnd);
}

Control _GUICtrlCreate(char *type,char *title,int posx,int posy,int w,int h,int style,HWND parent)
{
    Control nc;
    
    guis+=1;
    int x;
    for (x=0; x<guis; x++) if (gui[x]->hwnd==NULL) {newG->guix=x; break;};
    newG->title=title;
    newG->w=w;
    newG->h=h;
    newG->style=WS_VISIBLE|WS_CHILD|WS_EX_MDICHILD|style;
    newG->parent=parent;
    newG->posx=posx;
    newG->posy=posy;
    newG->classname=type;
    newG->useexstyle=false;
    newG->start=true;
    while(!finished) Sleep(10);
    finished=false;
    
    nc.Set(gui[x]->hwnd,type);
    gui[x]->hwnd=NULL;
    guis-=1;
    
    HFONT hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
    nc.SetFont(hFont);
    
    return nc;
}

Control GUIGetMessage(GUI *ngui)
{
    Control contemp;
    switch (ngui->msg)
    {
        case 0: break;
        case WM_CLOSE:
            contemp.cmsg=GUICLOSE;
            break;
        case WM_COMMAND:
            contemp.chwnd=(HWND)ngui->lparam;
            contemp.idoftype=LOWORD(ngui->wparam); //kein break, WM_COMMAND wird berliefert
        default:
            contemp.cmsg=ngui->msg;
            break;
    }
    ngui->msg=0;
    return contemp;
}

void GUISetState(GUI *ngui,int state)
{
    ShowWindow(ngui->hwnd,state);
    UpdateWindow(ngui->hwnd);
}

void GUISetFont(GUI *ngui,HFONT font)
{
    SendMessage(ngui->hwnd, WM_SETFONT, (WPARAM)font, MAKELPARAM(TRUE, 0));
}

void GUIEnable(GUI *ngui)
{
    EnableWindow(ngui->hwnd,TRUE);
}

void GUIDisable(GUI *ngui)
{
    EnableWindow(ngui->hwnd,FALSE);
}

void GUICtrlSetPos(Control nc,int x,int y)
{
    POINT size=WinGetSize(nc.chwnd);
    MoveWindow(nc.chwnd,x,y,size.x,size.y,TRUE);
}

void GUICtrlSetPos(Control nc,int x,int y,int w,int h)
{
    MoveWindow(nc.chwnd,x,y,w,h,TRUE);
}

void GUICtrlSetColor(Control nc,int color)
{
    SetTextColor(GetDC(nc.chwnd),color); //RGB(,,)
}

void GUICtrlSetBkColor(Control nc,int color)
{
    SetBkColor(GetDC(nc.chwnd),color); //RGB(,,)
}

void GUISetIcon(GUI *ngui,HICON hicon,HICON hiconsm)
{
    SetClassLong(ngui->hwnd,GCL_HICON,(LONG)hicon);
    SetClassLong(ngui->hwnd,GCL_HICONSM,(LONG)hiconsm);
}

void GUISetIcon(GUI *ngui,char *iconpath)
{
    HICON hicon;
    HICON hiconsm;
    ExtractIconEx(iconpath,0,&hicon,&hiconsm,1);
    SetClassLong(ngui->hwnd,GCL_HICON,(LONG)hicon);
    SetClassLong(ngui->hwnd,GCL_HICONSM,(LONG)hiconsm);
}

void GUISetCurser(GUI *ngui,char *name) //IDC_...
{
    SetClassLong(ngui->hwnd,GCL_HCURSOR,(LONG)LoadCursor(0,name));
}

int GUIGetStyle(GUI *ngui)
{
    return (int)(GetWindowLong(ngui->hwnd,GWL_STYLE));
}

void GUISetStyle(GUI *ngui,int style)
{
    SetWindowLong(ngui->hwnd,GWL_STYLE,style);
}

int GUIGetExstyle(GUI *ngui)
{
    return (int)(GetWindowLong(ngui->hwnd,GWL_EXSTYLE));
}

void GUISetExstyle(GUI *ngui,int exstyle)
{
    SetWindowLong(ngui->hwnd,GWL_EXSTYLE,exstyle);
}

GUI* GUICreate(char* title,int w,int h,int style,int exstyle,HWND parent,int posx,int posy)
{
    guis+=1;
    if (guis>50)
    {
         guis=50;
         MessageBox(0,"Nicht mehr als 50 GUIs erlaubt!","Achtung!",MB_OK|MB_ICONERROR);
    }
    int x;
    for (x=0; x<guis; x++) if (gui[x]->hwnd==NULL) {newG->guix=x; break;};
    

    long screenx = (long)GetSystemMetrics( SM_CXFULLSCREEN );
    long screeny = (long)GetSystemMetrics( SM_CYFULLSCREEN );
    int mx=screenx/2-w/2;
    int my=screeny/2-h/2;
    if (posx==CW_USEDEFAULT) posx=mx;
    if (posy==CW_USEDEFAULT) posy=my;
    
    newG->title=title;
    newG->w=w;
    newG->h=h;
    newG->style=style;
    newG->exstyle=exstyle;
    newG->parent=parent;
    newG->posx=posx;
    newG->posy=posy;
    newG->classname=clname;
    newG->useexstyle=true;
    newG->start=true;
    while(!finished) Sleep(10);
    finished=false;
    
    char path[201];
    GetModuleFileName(GetModuleHandle(NULL),path,201);
    GUISetIcon(gui[x],path); //Icon of Executable
    
    return gui[x];
}

int *msgfilter;
int filternum;
void GUIStartup()
{//CreateSolidBrush(RGB(,,))
    for(int x=0; x<=50; x++) gui[x]=new GUI();
    InitCommonControls();
    hinst=GetModuleHandle(NULL);
    wincl.hInstance = hinst;//hInstanceA
    wincl.lpszClassName = clname;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;//catch Doubleclicks
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;//no menu
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH)GetSysColorBrush(COLOR_BTNFACE);
    RegisterClassEx(&wincl);
    newG=new newGUI;
    newG->start=false;
    msgloop=true;
    filternum=2;
    msgfilter=new int[filternum];
    msgfilter[0]=WM_COMMAND;
    msgfilter[1]=WM_CLOSE;
    thread=CreateThread(NULL,0,_Handler,NULL,0,NULL);
}

void GUIRegisterMessage(int msg)
{//Messages that comes to GUIGetMessage -> you can just process these messages
    filternum+=1;
    int *t=msgfilter;
    msgfilter=new int[filternum];
    for (int x=0; x<filternum-1; x++) msgfilter[x]=t[x];
    msgfilter[filternum-1]=msg;
    delete[] t;
}

void GUIUnregisterMessage(int msg)
{
    filternum-=1;
    int *t=msgfilter;
    int num;
    msgfilter=new int[filternum];
    for (int x=0; x<filternum; x++) if (t[x]==msg) { num=x; break; }
    for (int x=0; x<filternum; x++)
    {
        if (x==num)
        {
            num=-1;
            continue;
        }
        if (num==-1)
        {
            msgfilter[x-1]=t[x];
        }
        else
        {
            msgfilter[x]=t[x];
        }
    }
    delete[] t;
}

void GUIShutdown()
{
    delete[] msgfilter;
    for(int x=0; x<=50; x++)
    {
        GUIDelete(gui[x]);
        delete gui[x];
    }
    msgloop=false;
    WaitForSingleObject(thread,5000);
    SuspendThread(thread);
    TerminateThread(thread,1);
    CloseHandle(thread);
}

DWORD WINAPI _Handler(LPVOID muell)
{
    MSG messages;
    ZeroMemory(&messages, sizeof(MSG));
    while(msgloop)
    {
        if(newG->start)
        {
            GUI *ngui;
            ngui=gui[newG->guix];
            if(newG->useexstyle) {
                 ngui->hwnd = CreateWindowEx (
                 newG->exstyle,       /* Extended possibilites for variation */
                 newG->classname,              /* Classname */
                 newG->title,         /* Title Text */
                 newG->style,         /* default window */
                 newG->posx,          /* Windows decides the position */
                 newG->posy,          /* where the window ends up on the screen */
                 newG->w,             /* The programs width */
                 newG->h,             /* and height in pixels */
                 newG->parent,        /* The window is a child-window to desktop */
                 NULL,                /* No menu */
                 hinst,               /* Program Instance handler */
                 NULL                 /* No Window Creation data */
                 );
            } else {
                 ngui->hwnd = CreateWindow(
                 newG->classname,              /* Classname */
                 newG->title,         /* Title Text */
                 newG->style,         /* default window */
                 newG->posx,          /* Windows decides the position */
                 newG->posy,          /* where the window ends up on the screen */
                 newG->w,             /* The programs width */
                 newG->h,             /* and height in pixels */
                 newG->parent,        /* The window is a child-window to desktop */
                 NULL,                /* No menu */
                 hinst,               /* Program Instance handler */
                 NULL                 /* No Window Creation data */
                 );
            }
            finished=true;
            newG->start=false;
        }
        if (dG.start)
        {
            dG.start=false;
            DestroyWindow(dG.hwnd);
            dG.fertig=true;
        }
        if(PeekMessage(&messages,NULL,0,0,PM_REMOVE)) //PM_REMOVE oder 0
        {
            TranslateMessage(&messages);
            DispatchMessage(&messages);
        }
        Sleep(5);
    }
    return messages.wParam;
}




LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    GUI *ngui;
    bool wasin=false;
    for (int x=0; x<guis; x++)
    {
        if(gui[x]->hwnd==hwnd)
        {
             ngui=gui[x];
             wasin=true;
             break;
        }
        Sleep(0);
    }
    if(!wasin) return DefWindowProc (hwnd, message, wParam, lParam);
    
    switch (message)
    {
        case WM_DESTROY:
            PostQuitMessage(0);
            guis-=1;
            ngui->hwnd=NULL; //Durch Pointer auch gui[x]=0
            break;
        default:
            for (int x=0; x<filternum; x++) if (message==msgfilter[x])
            {
                ngui->lparam=lParam;
                ngui->wparam=wParam;
                ngui->msg=message;
            }
            if(message==WM_CLOSE) return 0;
            return DefWindowProc (hwnd, message, wParam, lParam);
    }
    return 0;
}


char* _ThisFilename()
{
    char *path=new char[201];
    GetModuleFileName(GetModuleHandle(NULL),path,201);
    return path;
}

#endif

