#undef NOGDI
#undef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#include <windows.h>
#include <string>
#include <shellapi.h>

using namespace std;


#ifndef __WIN_H__
#define __WIN_H__



class _HWNDList
{
    public:
        HWND *tmp;
        int num;
        
        _HWNDList()
        {
            num=0;
            tmp=NULL;
        }
        
        void _Add(HWND hwnd)
        { //auch wenn Titel=""? hier: ja
            if (num==0)
            {
                num+=1;
                tmp=new HWND[num];
                tmp[num-1]=hwnd;
            }
            else
            {
                num+=1;
                HWND *tmp2=new HWND[num];
                tmp2[num-1]=hwnd;
                for (int x=0; x<num-1; x++) tmp2[x]=tmp[x];
                delete[] tmp;
                tmp=tmp2;
            }
        }
        
        HWND* _Get()
        {
            HWND *tmp2=new HWND[num+1];
            for (int x=1; x<=num; x++) tmp2[x]=tmp[x-1];
            tmp2[0]=(HWND)num;
            return tmp2;
        }
        
        void _Delete()
        {
            delete[] tmp;
            tmp=NULL;
            num=0;
        }
        
        ~_HWNDList()
        {
            _Delete();
        }
};

int WinGetState(HWND hwnd);
char* WinGetTitle(char *tile);
char* WinGetTitle(HWND hwnd);
HWND WinGetHandle(char *title);
HWND* WinList(bool mustvisible=true);
int WinGetStyle(HWND hwnd);
void WinSetStyle(HWND hwnd,int style);
int WinGetExstyle(HWND hwnd);
void WinSetExstyle(HWND hwnd,int exstyle);

_HWNDList _list;

BOOL CALLBACK _WinListProc(HWND hwnd, LPARAM lParam)
{
    if ((int)(lParam)==1)
    {
        if (IsWindowVisible(hwnd)) _list._Add(hwnd);
    }
    else
    {
        _list._Add(hwnd);
    }
	return TRUE;
}

HWND* WinList(bool mustvisible)
{
    EnumWindows(_WinListProc,(LPARAM)(mustvisible?1:0));
    HWND *list=_list._Get();
    _list._Delete();
    return list;
}

#define WINDESKTOP GetDesktopWindow()


BOOL CALLBACK _WinChildProc(HWND hwnd, LPARAM lParam)
{
    SendMessage(hwnd,WM_GETTEXT,(WPARAM)1000,lParam);
    return FALSE;
}

char* WinGetText(HWND hwnd)
{ //max 1000 characters
    char *txt=new char[1001];
    EnumChildWindows(hwnd,_WinChildProc,(LPARAM)txt);    
    return txt;
}

#define MIN_ALL        419
#define MIN_ALL_UNDO   416
void WinMinimizeAll()
{
    HWND lHwnd = FindWindow("Shell_TrayWnd",NULL);
	SendMessage(lHwnd,WM_COMMAND,MIN_ALL,0);
}
void WinMinimizeAllUndo()
{
    HWND lHwnd = FindWindow("Shell_TrayWnd",NULL);
	SendMessage(lHwnd,WM_COMMAND,MIN_ALL_UNDO,0);
}

void WinAddStyle(HWND hwnd,int style)
{
    WinSetStyle(hwnd,WinGetStyle(hwnd)|style);
}

void WinAddExstyle(HWND hwnd,int exstyle)
{
    WinSetExstyle(hwnd,WinGetExstyle(hwnd)|exstyle);
}

void WinDeleteStyle(HWND hwnd,int style)
{
    WinSetStyle(hwnd,WinGetStyle(hwnd)& ~style);
}

void WinDeleteExstyle(HWND hwnd,int exstyle)
{
    WinSetExstyle(hwnd,WinGetExstyle(hwnd)& ~exstyle);
}

void WinSetTrans(HWND hwnd,int alpha)
{
    WinAddExstyle(hwnd,WS_EX_LAYERED);
    SetLayeredWindowAttributes(hwnd,0,alpha,LWA_ALPHA);
    UpdateWindow(hwnd);
}

void WinSetStyle(HWND hwnd,int style)
{
    SetWindowLong(hwnd,GWL_STYLE,(LONG)style);
}

void WinSetExstyle(HWND hwnd,int exstyle)
{
    SetWindowLong(hwnd,GWL_EXSTYLE,(LONG)exstyle);
}

int WinGetStyle(HWND hwnd)
{
    return (int)GetWindowLong(hwnd,GWL_STYLE);
}

int WinGetExstyle(HWND hwnd)
{
    return (int)GetWindowLong(hwnd,GWL_EXSTYLE);
}

void WinSetOntop(HWND hwnd,bool ontop)
{
    if (ontop)
    {
        WinSetExstyle(hwnd,WinGetExstyle(hwnd)|WS_EX_TOPMOST);
    }
    else
    {
        WinSetExstyle(hwnd,WinGetExstyle(hwnd)& ~WS_EX_TOPMOST);
    }
}

void WinFlash(HWND hwnd)
{
    FlashWindow(hwnd,TRUE);
}

bool WinExists(HWND hwnd)
{
    return (IsWindow(hwnd)!=0);
}

bool WinExists(char *title)
{
    return (WinGetHandle(title)!=NULL);
}

int WinGetProcess(HWND hwnd)
{
    DWORD id;
    GetWindowThreadProcessId(hwnd, &id);
    return (int)id;
}

void WinClose(HWND hwnd)
{
    PostMessage(hwnd,WM_CLOSE,0,0);
}

void WinActivate(HWND hwnd)
{
    SetForegroundWindow(hwnd);
}

void WinSetTitle(HWND hwnd,char *title)
{
    SetWindowText(hwnd,title);
}

char* WinGetTitle(HWND hwnd)
{
    int length=GetWindowTextLength(hwnd)+1;
    char *temp=new char[length];
    GetWindowText(hwnd,temp,length);
    return temp;
}

char* WinGetTitle(char *tile)
{
    HWND win=NULL;
    string til=tile;
    HWND *list=WinList();
    for (int x=1; x<=(int)list[0]; x++)
    {
        string title=WinGetTitle(list[x]);
        if (title.find(til)!=-1)
        {
            win=list[x];
            break;
        }
    }
    return WinGetTitle(win);
}

HWND WinGetHandle(char *title)
{
    HWND win=NULL;
    string til=title;
    HWND *list=WinList(false); //mustvisible
    for (int x=1; x<=(int)list[0]; x++)
    {
        string title=WinGetTitle(list[x]);
        if (title.find(til)!=-1)
        {
            win=list[x];
            break;
        }
    }
    delete[] list;
    return win;
}

POINT WinGetPos(HWND hwnd)
{
    RECT rect; //left,top,right,bottom
    GetWindowRect(hwnd,&rect);
    
    POINT pos;
    pos.x=rect.left;
    pos.y=rect.top;
    return pos;
}

POINT WinGetSize(HWND hwnd)
{
    RECT rect; //left,top,right,bottom
    GetWindowRect(hwnd,&rect);
    
    POINT size;
    size.x=rect.right-rect.left;
    size.y=rect.bottom-rect.top;
    return size;
}

POINT WinGetClientSize(HWND hwnd)
{
    RECT rect; //right,bottom
    GetClientRect(hwnd,&rect);
    
    POINT size;
    size.x=rect.right;
    size.y=rect.bottom;
    return size;
}

POINT _ScreenToClient(HWND hwnd,int x,int y) //Screenposition to Clienposition
{
    POINT p;
    p.x=x;
    p.y=y;
    ScreenToClient(hwnd,&p);
    return p;
}

POINT _ClientToScreen (HWND hwnd,int x,int y)
{
    POINT p;
    p.x=x;
    p.y=y;
    ClientToScreen(hwnd,&p);
    return p;
}

void WinMove(HWND hwnd,int x,int y)
{
    POINT size=WinGetSize(hwnd);
    MoveWindow(hwnd,x,y,size.x,size.y,TRUE);
}

void WinMove(HWND hwnd,int x,int y,int w,int h)
{
    MoveWindow(hwnd,x,y,w,h,TRUE);
}

void WinKill(HWND hwnd)
{
    DWORD      dwResult;
	LRESULT lResult = SendMessageTimeout(hwnd, WM_CLOSE, 0, 0, SMTO_ABORTIFHUNG, 500, &dwResult);

	if (!lResult)
	{
		DWORD pid;
		GetWindowThreadProcessId(hwnd,&pid);
		HANDLE hProcess=OpenProcess(PROCESS_ALL_ACCESS,FALSE,pid);
		TerminateProcess(hProcess,0);
		CloseHandle(hProcess);
	}
}

HWND WinGetActive()
{
    return GetForegroundWindow();
}

bool WinActive(HWND hwnd)
{
    return (GetForegroundWindow()==hwnd);
}

void WinSetIcon(HWND hwnd,HICON hicon,HICON hiconsm)
{
    SetClassLong(hwnd,GCL_HICON,(LONG)hicon);
    SetClassLong(hwnd,GCL_HICONSM,(LONG)hiconsm);
}

void WinSetIcon(HWND hwnd,char *iconpath)
{
    HICON hicon;
    HICON hiconsm;
    ExtractIconEx(iconpath,0,&hicon,&hiconsm,1);
    SetClassLong(hwnd,GCL_HICON,(LONG)hicon);
    SetClassLong(hwnd,GCL_HICONSM,(LONG)hiconsm);
}

int WinGetState(HWND hwnd)
{
    WINDOWPLACEMENT wd;
    wd.length=sizeof(WINDOWPLACEMENT);
    
    GetWindowPlacement(hwnd,&wd);
    return wd.showCmd;
}

void WinSetState(HWND hwnd,int state)
{
    ShowWindow(hwnd,state);
}

bool _IsPressed(int key)
{
    SHORT s=GetAsyncKeyState(key);
    return (s&0x8000!=0);
}

void WinWait(char *title)
{
    while (!WinExists(title)) Sleep(10);
}

void WinWaitActive(HWND hwnd)
{
    while (WinGetActive()!=hwnd) Sleep(10);
}

void WinWaitClose(HWND hwnd)
{
    while (WinExists(hwnd)) Sleep(10);
}

void WinWaitNotActive(HWND hwnd)
{
    while (WinGetActive()==hwnd) Sleep(10);
}

void ShellExecute(char *file,char *para="",char *workdir=NULL,char *verb=NULL,int showflag=SW_SHOW);
void ShellExecute(char *file,char *para,char *workdir,char *verb,int showflag)
{
    ShellExecute(NULL,verb,file,para,workdir,showflag);
}

#endif


