#include "UDFs.h"
#include <fstream>

using namespace std;



void FadeOut(HWND hwnd)
{
    WinActivate(hwnd);
    for (int x=255; x>=0; x-=10)
    {
        WinSetTrans(hwnd,x);
    }
    WinSetTrans(hwnd,0);
}

void FadeIn(HWND hwnd)
{
    WinActivate(hwnd);
    for (int x=0; x<=255; x+=10)
    {
        WinSetTrans(hwnd,x);
    }
    WinSetTrans(hwnd,255);
}

char* GetIP(int num=1);
char* GetIP(int num)
{
    num--;
    char ac[80];
    if (gethostname(ac, sizeof(ac)) == SOCKET_ERROR) return "";
    hostent *phe = gethostbyname(ac);
    if (phe == 0) return "";
    in_addr addr;
    for (int i = 0; phe->h_addr_list[i] != 0; ++i) {
        memcpy(&addr, phe->h_addr_list[i], sizeof(in_addr));
        if (i==num) break;
    }
    return inet_ntoa(addr);
}

char* LoadLine(char *file,int line=1,char *sonst="");
char* LoadLine(char *file,int line,char *sonst)
{
    ifstream dat(file);
    if (dat.is_open())
    {
        int x=0;
        char *b=new char[5000];
        while (dat.good())
        {
            x++;
            dat.getline(b,5000);
            if (line==x) break;
        }
        if (!strcmp(b,"")) { dat.close(); return sonst; }
        dat.close();
        
        return b;
    }
    else { dat.close(); return sonst; }
}

void SaveLine(char *file,char *txt="");
void SaveLine(char *file,char *txt)
{
    ofstream dat(file,ofstream::out|ofstream::app);
    if (dat.is_open())
    {
        dat << txt << "\n";
        dat.close();
    }
}

char* _itoa(int z=0,int dec=10);
char* _itoa(int z,int dec)
{
    char *sz=new char[101];
    itoa(z,sz,dec);
    return sz;
}

char* _ThisDir()
{
    string d=GUIPath;
    d=d.substr(0,d.rfind("\\"));
    return const_cast<char*>(d.c_str());
}

char* _replace(char *src,char find,char rep)
{
    for (int x=0; x<strlen(src); x++) if (src[x]==find) src[x]=rep;
    return src;
}

char* _FileDialog(bool save=false,char *title="",char *datei="",char *dir="",char *filter="Alle(*.*)",int flag=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,HWND parent=NULL);
char* _FileDialog(bool save,char *title,char *datei,char *dir,char *filter,int flag,HWND parent)
{
	OPENFILENAME	ofn;
	char			szFile[65536] = "";	// initalize entire array with null characters
	char			szTitle[32768];
	char			szDir[30000+1];
	char			szFilter[(30000*2)+1];
	string			sFilter, sTemp;
	int				nPos1, nPos2;
	char            *vResult="",RET[60001];

	strncpy(szTitle, title, 32767);		// Get the title
	szTitle[32767] = '\0';

	strncpy(szDir, dir, 30000);		// Get the directory
	szDir[_MAX_PATH] = '\0';

	strncpy(szFilter, filter, 30000);		// Get filter
	szFilter[30000] = '\0';

	// Work out the nightmare double nulled c string that we need for the filter
	// All Files (*.*)\0*.*\0\0
	sTemp = szFilter;

	nPos1 = sTemp.find_first_of("(");
	nPos2 = sTemp.find_first_of(")");

	if (nPos1 == sTemp.length() || nPos2 == sTemp.length() || nPos2 < nPos1)
	{
		return "";
	}

	sFilter.assign(sTemp, nPos1+1, nPos2);
	nPos1 = (unsigned int)strlen(szFilter);
	nPos2 = sFilter.length();
	szFilter[nPos1++] = '\0';
	strcpy(&szFilter[nPos1], sFilter.c_str());
	nPos1 = nPos1 + nPos2;
	szFilter[nPos1++] = '\0';
	szFilter[nPos1++] = '\0';

	strcpy(szFile, datei);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= parent;
	ofn.lpstrFilter		= szFilter;
	ofn.lpstrTitle		= szTitle;
	ofn.nMaxFile		= sizeof(szFile)-1;		// easier to maintain.  Returns memory allocated, not string size.
	ofn.lpstrFile		= szFile;
	ofn.lpstrInitialDir = szDir;				// Set working dir

	if(!save)
	{
		if(GetOpenFileName(&ofn))
		{
			if(flag & OFN_ALLOWMULTISELECT)
			{
				size_t len=strlen(ofn.lpstrFile);
				strcpy(RET,ofn.lpstrFile);
				ofn.lpstrFile+=len+1;
				while(ofn.lpstrFile[0])
				{
					len=strlen(ofn.lpstrFile);
					strcat(RET,"|");
					strcat(RET,ofn.lpstrFile);
					ofn.lpstrFile+=len+1;
				}
				vResult = RET;
			}
			else
				vResult = ofn.lpstrFile;
		}
	}
	else
	{
		if(GetSaveFileName(&ofn))
			vResult = ofn.lpstrFile;
	}

	return vResult;
}

char* FileSaveDialog(char *title="",char *initdir="",char *filter="Alle(*.*)",int flag=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,HWND parent=NULL);
char* FileSaveDialog(char *title,char *initdir,char *filter,int flag,HWND parent)
{
    return _FileDialog(true,title,"",initdir,filter,flag,parent);
}

char* FileOpenDialog(char *title="",char *initdir="",char *filter="Alle(*.*)",int flag=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,HWND parent=NULL);
char* FileOpenDialog(char *title,char *initdir,char *filter,int flag,HWND parent)
{
    return _FileDialog(false,title,"",initdir,filter,flag,parent);
}

void _FCM3(char *f)
{
    long readlen;
    char data[10000];
    
    MoveFile(f,cat(f,"2"));
    
    ofstream out(f,ios_base::binary|ios_base::out);
    ifstream in(cat(f,"2"),ios_base::binary|ios_base::in);
    
    in.seekg (0, ios::end);
    readlen = in.tellg();
    in.seekg (0, ios::beg);

    readlen-=3;
    
    while (readlen > 10000)
    {
        in.read(data,10000);
        out.write(data,10000);
        readlen -= 10000;
    }
    in.read(data,readlen);
    out.write(data,readlen);
    
    in.close();
    out.close();
    DeleteFile(cat(f,"2"));
}




void _Aufnahme(char *instf,char *sf,HWND fade)
{
    char temp[301];
    GetTempPath(300,temp);
    char *rp=cat(temp,"_record.rec");
    DeleteFile(rp);
    ofstream rec(rp);
    FadeOut(fade);
    MessageBox(fade,"Esc um Aufnahme zu beenden","Info",0);
    
    ShellExecute(instf);
    while (!_IsPressed(0x1B))
    {
        if (_IsPressed(0x1)) //Maus links
        {
            HWND win=WinGetActive();
			char *title=WinGetTitle(win);
			rec << title << "\n";
			Control focus=ControlGetFocus(win);
			rec << focus.id << "\n"; //Pfad: Inputfeld muss angeklickt werden
			rec << focus.Read() << "\n";
			POINT m;
			GetCursorPos(&m);
			m=_ScreenToClient(win,m.x,m.y);
			rec << m.x << "," << m.y << "\n";
			while (_IsPressed(0x1)) _Sleep(10);
		}
        _Sleep(10);
    }
    
    FadeIn(fade);
    rec.close();
    _FilePutTogether(rp,instf,sf);
    string s=instf;
    int rfind=s.rfind(".");
    if (rfind==-1) s="exe";
    else s=s.substr(rfind+1);
    ofstream o(sf,ofstream::out|ofstream::app|ofstream::binary);
    o << s.c_str();
    o.close();
    DeleteFile(rp);
}

void _Ausfuehren(char *f,HWND fade)
{
    char temp[301];
    GetTempPath(300,temp);
    CopyFile(f,cat(temp,"__temp.isms"),FALSE);
    f=cat(temp,"__temp.isms");
    ifstream echeck(f,ifstream::in|ifstream::binary);
    echeck.seekg(0,ios_base::end);
    echeck.seekg((int)echeck.tellg()-3);
    char endung[4];
    echeck.read(endung,3);
    endung[3]='\0';
    echeck.close();
    _FCM3(f);
    
    char *rp=cat(temp,"_record.rec");
    char *ip=cat(temp,cat("_inst.",endung));
    DeleteFile(rp);
    DeleteFile(ip);
    _FileSplit(f,rp,ip);
    DeleteFile(f);
    FadeOut(fade);
    ifstream rec(rp);
    
    ShellExecute(ip);
    char data[1001];
    char tit[1001],control[1001];
    HWND title;
    bool ende=false;
    while (!ende)
    {
    	rec.getline(data,1000);
    	if (rec.eof()) break;
    	strcpy(tit,data);
    	WinWait(tit);
    	title=WinGetHandle(tit);
    
    	rec.getline(data,1000);
    	strcpy(control,data);
    	while (true)
    	{
            WinWait(tit);
         	title=WinGetHandle(tit);
            Any a1=ControlCommand(title,control,"IsVisible");
            Any a2=ControlCommand(title,control,"IsEnabled");
            if (a1.GetInt()==1 && a2.GetInt()==1) break;
        	_Sleep(10);
    	}
    	ControlClick(title,control);
    
    	rec.getline(data,1000);
    	ControlSetText(title,control,data);
    
    	rec.getline(data,1000);
    	if (rec.eof()) ende=true;
    	Control nc=ControlGetHandle(title,control);
    	if (nc.chwnd!=NULL && strnicmp(control,"Button",6))
    	{
    		ControlClick(title,control);
    		string s1=data;
    		int pos=s1.find(",");
    		string s2=s1.substr(pos+1);
    		s1=s1.substr(0,pos-1);
    		POINT p={atoi(s1.c_str()),atoi(s2.c_str())};
    		p=_ClientToScreen(title,p.x,p.y);
    		WinActivate(title);
    		WinWaitActive(title);
    		RECT r={p.x,p.y,0,0};
    		ClipCursor(&r);
    		MouseClick("primary",p.x,p.y,1);
    		ClipCursor(NULL);
    	}
    	_Sleep(10);
    }
    
    rec.close();
    DeleteFile(rp);
    DeleteFile(ip);
    FadeIn(fade);
}






int main()
{
    GUIStartup();
    TCPStartup();
    GUI *gui=GUICreate("ISMS [InstallationSaver & MultiSender] - TheShadowAE", 401, 272);
    Control Group1 = GUICtrlCreateGroup(gui,"Aufnahme", 8, 8, 193, 121);
    Control Input1 = GUICtrlCreateInput(gui,"Installationsdatei", 16, 24, 145, 21);
    Control Input2 = GUICtrlCreateInput(gui,"Speicherort", 16, 56, 145, 21);
    Control Button1 = GUICtrlCreateButton(gui,"Aufnahme", 16, 88, 177, 25, WS_GROUP);
    Control Button2 = GUICtrlCreateButton(gui,"...", 168, 24, 25, 25, WS_GROUP);
    Control Button3 = GUICtrlCreateButton(gui,"...", 168, 56, 25, 25, WS_GROUP);
    Control Group2 = GUICtrlCreateGroup(gui,"Ausfhrung", 8, 144, 193, 89);
    Control Input3 = GUICtrlCreateInput(gui,"Dateipfad", 16, 160, 145, 21);
    Control Button4 = GUICtrlCreateButton(gui,"...", 168, 160, 25, 25, WS_GROUP);
    Control Button5 = GUICtrlCreateButton(gui,"Ausfhren", 16, 192, 177, 25, WS_GROUP);
    Control Group4 = GUICtrlCreateGroup(gui,"Netzwerk", 232, 8, 153, 225);
    Control Combo1 = GUICtrlCreateInput(gui,"IP", 240, 24, 129, 21);
    Control Input4 = GUICtrlCreateInput(gui,"Port", 240, 56, 129, 21);
    Control Button6 = GUICtrlCreateButton(gui,"Datei freigeben", 240, 104, 129, 25, WS_GROUP);
    Control Button7 = GUICtrlCreateButton(gui,"Datei empfangen", 240, 184, 129, 25, WS_GROUP);
    Control Checkbox1 = GUICtrlCreateCheckbox(gui,"direkt ausfhren", 240, 160, 129, 17);
    
    char *f=cat(cat(_ThisDir(),"\\"),"ISMS_Settings.txt");
    Combo1=LoadLine(f,1,GetIP(1));
    Input4=LoadLine(f,2,"5123");
    if (atoi(LoadLine(f,3,"1"))==1) ControlCommand(gui->hwnd,"Button11","Check");
    
    WinSetTrans(gui->hwnd,0);
    GUISetState(gui);
    FadeIn(gui->hwnd);
    
    while (true)
    {
        Control msg=GUIGetMessage(gui);
        if (msg==GUICLOSE) break;
        
        else if(msg==Button2)
        {
            char *path=FileOpenDialog("Installation","","Installation\0*.exe;*.msi\0",OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,gui->hwnd);
            if (strcmp(path,"")) Input1=path;
        }
        else if(msg==Button3)
        {
            char *path=FileSaveDialog("Installationsdatei","","Installation\0*.isms\0",OFN_PATHMUSTEXIST,gui->hwnd);
            if (strcmp(path,""))
            {
                string p=path;
                int x=p.rfind(".isms");
                if (x!=-1) p=p.replace(x,5,"");
                path=cat(const_cast<char*>(p.c_str()),".isms");
                Input2=path;
            }
        }
        else if(msg==Button4)
        {
            char *path=FileOpenDialog("Installationsdatei","","Installation\0*.isms\0",OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,gui->hwnd);
            if (strcmp(path,"")) Input3=path;
        }
        
        //Aufnahme
        else if (msg==Button1)
        {
            char *t1=Input1.Read(),*t2=Input2.Read();
            if (stricmp(t1,"Installationsdatei") && stricmp(t2,"Speicherort")) _Aufnahme(t1,t2,gui->hwnd);
        }
        else if (msg==Button5)
        {
            char *t=Input3.Read();
            if (stricmp(t,"Dateipfad")) _Ausfuehren(t,gui->hwnd);
        }
        else if (msg==Button6)
        {
            SOCKET sock=TCPListen(Combo1.Read(),atoi(Input4.Read()),5);
            if (sock==0) { MessageBox(gui->hwnd,"Datei kann nicht freigegeben werden!","Info",0); continue; }
            char *file=FileOpenDialog("Installationsdatei","","Installation\0*.isms\0",OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,gui->hwnd);
            if (!strcmp(file,"")) continue;
            MessageBox(gui->hwnd,"Esc um Freigabe zu beenden","Info",0);
            char data[10001];
            data[10000]='\0';
            ifstream in;
            while (!_IsPressed(0x1B))
            {
                SOCKET acc=TCPAccept(sock);
                if (acc!=0)
                {
                    in.open(file,ios_base::binary|ios_base::in);
                    long readlen;
                    in.seekg (0, ios::end);
                    readlen = in.tellg();
                    in.seekg (0, ios::beg);
                    
                    char *rlc=_itoa(readlen);
                    TCPSend(acc,rlc,100);
                    delete[] rlc;
                    
                    while (readlen > 10000)
                    {
                        in.read(data,10000);
                        TCPSend(acc,data,10000);
                        readlen -= 10000;
                    }
                    in.read(data,readlen);
                    TCPSend(acc,data,readlen);
                    
                    in.close();
                    TCPCloseSocket(acc);
                }
                _Sleep(10);
            }
            TCPCloseSocket(sock);
        }
        else if (msg==Button7)
        {
            SOCKET sock=TCPConnect(Combo1.Read(),atoi(Input4.Read()));
            if (sock==0) { MessageBox(gui->hwnd,"Freigabe nicht gefunden!","Info",0); continue; }
            char *file=FileSaveDialog("Installationsdatei","","Installation\0*.isms\0",OFN_PATHMUSTEXIST,gui->hwnd);
            if (!strcmp(file,"")) continue;
            string p=file;
            int x=p.rfind(".isms");
            if (x!=-1) p=p.replace(x,5,"");
            file=cat(const_cast<char*>(p.c_str()),".isms");
            char *data;
            ofstream out(file,ios_base::binary|ios_base::out);
            while (true)
            {
                data=TCPRecv(sock,100);
                if (strcmp(data,"")) break;
                _Sleep(10);
            }
            
            int readlen=atoi(data);
            while (readlen>=10000)
            {
                delete[] data;
                data=TCPRecv(sock,10000);
                out.write(data,10000);
                readlen-=10000;
            }
            delete[] data;
            data=TCPRecv(sock,readlen);
            out.write(data,readlen);
            delete[] data;
            out.close();
            TCPCloseSocket(sock);
            
            Any a=ControlCommand(gui->hwnd,"Button11","IsChecked");
            if (a.GetInt()==1) _Ausfuehren(file,gui->hwnd);
        }
        
        Sleep(10);
    }
    
    DeleteFile(f);
    SaveLine(f,Combo1.Read());
    SaveLine(f,Input4.Read());
    Any a=ControlCommand(gui->hwnd,"Button11","IsChecked");
    SaveLine(f,_itoa(a.GetInt()));
    
    FadeOut(gui->hwnd);
    TCPShutdown();
    GUIShutdown();
    return 0;
}







/*int main()
{
    ShellExecute("notepad");
    WinWait("Editor");
    HWND hwnd=WinGetHandle("Editor");
    if (hwnd!=NULL)
    {
        WinActivate(hwnd);
        ControlClick(hwnd,"Edit1");
        Control nc=ControlGetHandle(hwnd,"Edit1");
        nc.SetData("Hallo, solange hier kein \"Exit\"steht, geht gar nichts mehr!");
        while (nc!="Exit") Sleep(10);
        
        ControlFocus(hwnd,"Edit1");
        nc=ControlGetFocus(hwnd);
        nc.SetData(nc.id);
        
        MessageBox(0,"Du hast jetzt Zeit eine 2. Zeile einzugeben, danach auf OK klicken","",0);
        Any a=ControlCommand(hwnd,"Edit1","GetLine",2);
        MessageBox(0,a.GetSz(),"",0);
        ControlSend(hwnd,"Edit1","Hallo^s",true,0,0);
    }
    return 0;
}*/


/* // List all Visible Windows
int main()
{
    HWND *list=WinList(true);
    for (int x=1; x<=(int)list[0]; x++)
    {
        char num[5];
        itoa(x,num,10);
        char *title=WinGetTitle(list[x]);
        if (strcmp(title,"") && strcmp(title,"Program Manager")) MessageBox(0,title,cat("Fenster: ",num),0);
    }
    return 0;
}*/





/* //GUI Beispiel
int main()
{
    GUIStartup();
    GUIRegisterMessage(WM_RBUTTONDBLCLK);
    //GUIUnregisterMessage(WM_COMMAND); //Keine Klicks erkannt
    GUI *g=GUICreate("Hallo",220,100);
    Control button=GUICtrlCreateButton(g,"Klick mich!",5,5,200,20);
    Control input=GUICtrlCreateInput(g,"Mach den Text hier zu \"Hallo\"",5,35,200,20);
    input.SetData("");
    Test(g->hwnd);
    GUISetState(g);
    
    while(true)
    {
        Control msg=GUIGetMessage(g);
        if (msg==GUICLOSE) break;
        if (msg==button) GUICtrlDelete(button);
        if (input=="Hallo") break;
        if (msg==WM_RBUTTONDBLCLK) MessageBox(0,"rechter Double-Click","",0);
        Sleep(10);
    }
    
    GUIShutdown();
    return 0;
}
*/
